﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Drawing;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Threading;
using System.Data.OleDb;
using Infragistics.WebUI.UltraWebNavigator;
using Infragistics.WebUI.UltraWebGrid;
using MIS_Web.MIS_WebData;
using MIS_CClass;
using MIS_Base;
using MIS_Domain;
using MIS_WebApp;
using MIS_Domain.Broker;
using MIS_IGUtil.WebTree;

namespace MIS_Web
{
    public partial class global_empl_cost : System.Web.UI.Page
    {
        private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
        private System.Data.OleDb.OleDbConnection oleDbConnection1;
        private System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
        private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
        private System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
        private DSEmplCost dsEmplCost1;
        private DSGlobalCost dsGlobalCost1;
        private System.Data.OleDb.OleDbCommand oleDbSelectCommand2;
        private System.Data.OleDb.OleDbDataAdapter daClient;
        private System.Data.OleDb.OleDbCommand oleDbSelectCommand3;
        private System.Data.OleDb.OleDbDataAdapter daGlobalAddOnCost;
        private OleDbCommand oleDbSelectCommand4;
        private OleDbDataAdapter daGlobalCost;
        private OleDbCommand oleDbSelectCommand5;
        private OleDbDataAdapter daEmplCostParent;
        private System.Data.OleDb.OleDbDataAdapter daEmplCostChild;
        private string parentTable = "Employee";
        private string childTable = "MIS_EmplCost";
        private string globalCostTable = "MIS_GlobalCostCategory";
        private string globalAddOnCostTable = "MIS_GlobalCostAddOn";
        private MIS_WebApp.MEmplCostContext pageContext = null;
        private int emplCostKey = 0;


        // ------------------------------------------------------------------------------------------
        //  Seite wird geladen
        // ------------------------------------------------------------------------------------------
        protected void Page_Load( object sender, EventArgs e )
        {
            try
            {
                // Init Data Components (OleDbAdapters, etc.)
                InitializeComponent();
                this.oleDbConnection1.ConnectionString = MIS_Base.MConnectionString.GetConnectionString();
                this.lblError.Text = "";

                // Benutzer prüfen
                MUser sessionUser = (MIS_Domain.MUser)Session["USER"];
                if ( !Response.IsClientConnected || sessionUser == null )
                    Response.Redirect( "idle_client.aspx", true );
                else
                {
                    // Mind. Leserechte um Seite zu sehen
                    if ( !sessionUser.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Read ) )
                        Response.Redirect( "no_rights.aspx", true );
                    // Benutzerrechte
                    SetupRights( sessionUser );
                }

                // Kontext abfragen bzw. erstellen
                pageContext = (MIS_WebApp.MEmplCostContext)Session[MESessionObjectIdentifier.SO_GlobalEmplCost];
                if ( pageContext == null )
                {
                    pageContext = new MEmplCostContext();
                    Session.Add( MESessionObjectIdentifier.SO_GlobalEmplCost, pageContext );
                }

                // Daten laden
                InitData();

                // Kontext nachführen
                if ( Page.IsPostBack )
                {
                    if ( this.cbClient.SelectedRow != null )
                        pageContext.ClientOrgUnitId = Convert.ToInt32( this.cbClient.SelectedRow.Cells.FromKey( "OrgUnitId" ).Value );
                    if ( this.orgTree.SelectedNode != null )
                        pageContext.OrgUnitId = Convert.ToInt32( this.orgTree.SelectedNode.Tag );
                    pageContext.ShowInactiveEmpl = this.checkInactiveEmpl.Checked;
                }

                if ( !Page.IsPostBack )
                {
                    // Hilfeseite
                    // ----------
                    Session.Add( "HELPID", "idh_global_empl_cost.htm" );

                    // Daten binden
                    // ------------
                    this.cbClient.DataBind();
                    this.cbEmployment.DataBind();
                    this.cbSearchCost.DataBind();
                    this.cbSearchAddOnCost.DataBind();
                    this.cbActionOption.DataBind();
                    this.cbActionCost.DataBind();
                    this.cbActionAddOnCost.DataBind();
                    this.grid.DataBind();

                    // Defaults
                    // --------
                    this.cbEmployment.SelectedIndex = 0;
                    this.cbActionOption.SelectedIndex = 0;
                    this.edActionRefDate.Value = DateTime.Today;

                    // WebTab erste Seite setzen
                    // -------------------------
                    this.webTab.SelectedTabIndex = 0;

                    // Kontext : letzten Mandanten auswählen
                    // -------------------------------------
                    if ( pageContext.ClientOrgUnitId > 0 )
                    {
                        DataRow dataRow = this.dsEmplCost1.Tables["OrgUnitClient"].Rows.Find( (int)pageContext.ClientOrgUnitId );
                        this.cbClient.SelectedIndex = dataRow != null ? this.dsEmplCost1.Tables["OrgUnitClient"].Rows.IndexOf( dataRow ) : 0;
                    }
                    else
                        this.cbClient.SelectedIndex = 0;
                    // Selektion jetzt vorhanden ?
                    if ( this.cbClient.SelectedIndex >= 0 )
                    {
                        // Organisation laden
                        MOrgClient clientNode = new MOrgClient( new MOrgNodeInfo( Convert.ToInt32( cbClient.DataValue ), cbClient.DisplayValue ) );
                        LoadOrgTree( clientNode );
                        // Letzte Organisation aus Kontext auswählen
                        // ------------------------------------------
                        if ( pageContext.OrgUnitId > 0 )
                        {
                            this.orgTree.SelectedNode = this.orgTree.Find( pageContext.OrgUnitId );
                            if ( this.orgTree.SelectedNode != null )
                            {
                                // Init DataAdapter Select-Command
                                new MOrgBroker().InitSearchByOrgCmd( this.daEmplCostParent.SelectCommand, Convert.ToInt32( cbClient.DataValue ),
                                    Convert.ToInt32( this.orgTree.SelectedNode.Tag ), this.checkInactiveEmpl.Checked, MEEmploymentOptions.All );
                                pageContext.SelectParentCmd = this.daEmplCostParent.SelectCommand.CommandText;
                                // MA Cost für die Auswahl laden
                                LoadEmplCost();
                            }
                        }
                    }

                }
            }
            catch ( ThreadAbortException ) { }
            catch ( Exception x )
            {
                new ErrorLogger().LogError( x );
                this.lblError.Text = ErrorLogger.StandardCommonErrorMsg;
            }
        }
        // ------------------------------------------------------------------------------------------
        //  Designer Datenkomponenten initialisieren
        // ------------------------------------------------------------------------------------------
        private void InitializeComponent()
        {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager( typeof( global_empl_cost ) );
            this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
            this.oleDbConnection1 = new System.Data.OleDb.OleDbConnection();
            this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
            this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
            this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
            this.daEmplCostChild = new System.Data.OleDb.OleDbDataAdapter();
            this.oleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
            this.daClient = new System.Data.OleDb.OleDbDataAdapter();
            this.oleDbSelectCommand3 = new System.Data.OleDb.OleDbCommand();
            this.daGlobalAddOnCost = new System.Data.OleDb.OleDbDataAdapter();
            this.oleDbSelectCommand4 = new System.Data.OleDb.OleDbCommand();
            this.daGlobalCost = new System.Data.OleDb.OleDbDataAdapter();
            this.oleDbSelectCommand5 = new System.Data.OleDb.OleDbCommand();
            this.daEmplCostParent = new System.Data.OleDb.OleDbDataAdapter();
            this.dsEmplCost1 = new DSEmplCost();
            ( (System.ComponentModel.ISupportInitialize)( this.dsEmplCost1 ) ).BeginInit();
            // 
            // oleDbSelectCommand1
            // 
            this.oleDbSelectCommand1.CommandText = resources.GetString( "oleDbSelectCommand1.CommandText" );
            this.oleDbSelectCommand1.Connection = this.oleDbConnection1;
            // 
            // oleDbConnection1
            // 
            this.oleDbConnection1.ConnectionString = "Provider=ASAProv.90;Data Source=MIS;User ID=dba";
            // 
            // oleDbInsertCommand1
            // 
            this.oleDbInsertCommand1.CommandText = resources.GetString( "oleDbInsertCommand1.CommandText" );
            this.oleDbInsertCommand1.Connection = this.oleDbConnection1;
            this.oleDbInsertCommand1.Parameters.AddRange( new System.Data.OleDb.OleDbParameter[] {
            new System.Data.OleDb.OleDbParameter("EmplCostId", System.Data.OleDb.OleDbType.Integer, 0, "EmplCostId"),
            new System.Data.OleDb.OleDbParameter("OrgUnitId", System.Data.OleDb.OleDbType.Integer, 0, "OrgUnitId"),
            new System.Data.OleDb.OleDbParameter("GlobalCostCategoryId", System.Data.OleDb.OleDbType.Integer, 0, "GlobalCostCategoryId"),
            new System.Data.OleDb.OleDbParameter("GlobalCostAddOnId", System.Data.OleDb.OleDbType.Integer, 0, "GlobalCostAddOnId"),
            new System.Data.OleDb.OleDbParameter("ValidFrom", System.Data.OleDb.OleDbType.DBDate, 0, "ValidFrom"),
            new System.Data.OleDb.OleDbParameter("HourBase", System.Data.OleDb.OleDbType.Integer, 0, "HourBase"),
            new System.Data.OleDb.OleDbParameter("HourCost", System.Data.OleDb.OleDbType.Single, 0, "HourCost"),
            new System.Data.OleDb.OleDbParameter("AddOnHourCost", System.Data.OleDb.OleDbType.Single, 0, "AddOnHourCost"),
            new System.Data.OleDb.OleDbParameter("CostLocked", System.Data.OleDb.OleDbType.SmallInt, 0, "CostLocked"),
            new System.Data.OleDb.OleDbParameter("AddOnLocked", System.Data.OleDb.OleDbType.SmallInt, 0, "AddOnLocked"),
            new System.Data.OleDb.OleDbParameter("CostType", System.Data.OleDb.OleDbType.SmallInt, 0, "CostType")} );
            // 
            // oleDbUpdateCommand1
            // 
            this.oleDbUpdateCommand1.CommandText = resources.GetString( "oleDbUpdateCommand1.CommandText" );
            this.oleDbUpdateCommand1.Connection = this.oleDbConnection1;
            this.oleDbUpdateCommand1.Parameters.AddRange( new System.Data.OleDb.OleDbParameter[] {
            new System.Data.OleDb.OleDbParameter("EmplCostId", System.Data.OleDb.OleDbType.Integer, 0, "EmplCostId"),
            new System.Data.OleDb.OleDbParameter("OrgUnitId", System.Data.OleDb.OleDbType.Integer, 0, "OrgUnitId"),
            new System.Data.OleDb.OleDbParameter("GlobalCostCategoryId", System.Data.OleDb.OleDbType.Integer, 0, "GlobalCostCategoryId"),
            new System.Data.OleDb.OleDbParameter("GlobalCostAddOnId", System.Data.OleDb.OleDbType.Integer, 0, "GlobalCostAddOnId"),
            new System.Data.OleDb.OleDbParameter("ValidFrom", System.Data.OleDb.OleDbType.DBDate, 0, "ValidFrom"),
            new System.Data.OleDb.OleDbParameter("HourBase", System.Data.OleDb.OleDbType.Integer, 0, "HourBase"),
            new System.Data.OleDb.OleDbParameter("HourCost", System.Data.OleDb.OleDbType.Single, 0, "HourCost"),
            new System.Data.OleDb.OleDbParameter("AddOnHourCost", System.Data.OleDb.OleDbType.Single, 0, "AddOnHourCost"),
            new System.Data.OleDb.OleDbParameter("CostLocked", System.Data.OleDb.OleDbType.SmallInt, 0, "CostLocked"),
            new System.Data.OleDb.OleDbParameter("AddOnLocked", System.Data.OleDb.OleDbType.SmallInt, 0, "AddOnLocked"),
            new System.Data.OleDb.OleDbParameter("CostType", System.Data.OleDb.OleDbType.SmallInt, 0, "CostType"),
            new System.Data.OleDb.OleDbParameter("Original_EmplCostId", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((byte)(0)), ((byte)(0)), "EmplCostId", System.Data.DataRowVersion.Original, null)} );
            // 
            // oleDbDeleteCommand1
            // 
            this.oleDbDeleteCommand1.CommandText = "DELETE FROM \"DBA\".\"MIS_EmplCost\" WHERE ((\"EmplCostId\" = ?))";
            this.oleDbDeleteCommand1.Connection = this.oleDbConnection1;
            this.oleDbDeleteCommand1.Parameters.AddRange( new System.Data.OleDb.OleDbParameter[] {
            new System.Data.OleDb.OleDbParameter("Original_EmplCostId", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((byte)(0)), ((byte)(0)), "EmplCostId", System.Data.DataRowVersion.Original, null)} );
            // 
            // daEmplCostChild
            // 
            this.daEmplCostChild.DeleteCommand = this.oleDbDeleteCommand1;
            this.daEmplCostChild.InsertCommand = this.oleDbInsertCommand1;
            this.daEmplCostChild.SelectCommand = this.oleDbSelectCommand1;
            this.daEmplCostChild.TableMappings.AddRange( new System.Data.Common.DataTableMapping[] {
            new System.Data.Common.DataTableMapping("Table", "MIS_EmplCost", new System.Data.Common.DataColumnMapping[] {
                        new System.Data.Common.DataColumnMapping("EmplCostId", "EmplCostId"),
                        new System.Data.Common.DataColumnMapping("OrgUnitId", "OrgUnitId"),
                        new System.Data.Common.DataColumnMapping("GlobalCostCategoryId", "GlobalCostCategoryId"),
                        new System.Data.Common.DataColumnMapping("GlobalCostAddOnId", "GlobalCostAddOnId"),
                        new System.Data.Common.DataColumnMapping("ValidFrom", "ValidFrom"),
                        new System.Data.Common.DataColumnMapping("HourBase", "HourBase"),
                        new System.Data.Common.DataColumnMapping("HourCost", "HourCost"),
                        new System.Data.Common.DataColumnMapping("AddOnHourCost", "AddOnHourCost"),
                        new System.Data.Common.DataColumnMapping("CostLocked", "CostLocked"),
                        new System.Data.Common.DataColumnMapping("AddOnLocked", "AddOnLocked"),
                        new System.Data.Common.DataColumnMapping("CostType", "CostType")})} );
            this.daEmplCostChild.UpdateCommand = this.oleDbUpdateCommand1;
            // 
            // oleDbSelectCommand2
            // 
            this.oleDbSelectCommand2.CommandText = "SELECT  OrgUnitId, Name\r\nFROM     DBA.OrgUnit\r\nWHERE  (ObjType = \'C\') AND (PartOf" +
                " IS NULL)\r\nORDER BY Name";
            this.oleDbSelectCommand2.Connection = this.oleDbConnection1;
            // 
            // daClient
            // 
            this.daClient.AcceptChangesDuringFill = false;
            this.daClient.SelectCommand = this.oleDbSelectCommand2;
            this.daClient.TableMappings.AddRange( new System.Data.Common.DataTableMapping[] {
            new System.Data.Common.DataTableMapping("Table", "OrgUnit", new System.Data.Common.DataColumnMapping[] {
                        new System.Data.Common.DataColumnMapping("OrgUnitId", "OrgUnitId"),
                        new System.Data.Common.DataColumnMapping("Name", "Name")})} );
            // 
            // oleDbSelectCommand3
            // 
            this.oleDbSelectCommand3.CommandText = "SELECT  GlobalCostAddOnId, Name\r\nFROM     DBA.MIS_GlobalCostAddOn\r\nORDER BY Name";
            this.oleDbSelectCommand3.Connection = this.oleDbConnection1;
            // 
            // daGlobalAddOnCost
            // 
            this.daGlobalAddOnCost.SelectCommand = this.oleDbSelectCommand3;
            this.daGlobalAddOnCost.TableMappings.AddRange( new System.Data.Common.DataTableMapping[] {
            new System.Data.Common.DataTableMapping("Table", "MIS_GlobalCostAddOn", new System.Data.Common.DataColumnMapping[] {
                        new System.Data.Common.DataColumnMapping("GlobalCostAddOnId", "GlobalCostAddOnId"),
                        new System.Data.Common.DataColumnMapping("Name", "Name")})} );
            // 
            // oleDbSelectCommand4
            // 
            this.oleDbSelectCommand4.CommandText = "SELECT  GlobalCostCategoryId, Name\r\nFROM     DBA.MIS_GlobalCostCategory\r\nORDER BY" +
                " Name";
            this.oleDbSelectCommand4.Connection = this.oleDbConnection1;
            // 
            // daGlobalCost
            // 
            this.daGlobalCost.SelectCommand = this.oleDbSelectCommand4;
            this.daGlobalCost.TableMappings.AddRange( new System.Data.Common.DataTableMapping[] {
            new System.Data.Common.DataTableMapping("Table", "MIS_GlobalCostCategory", new System.Data.Common.DataColumnMapping[] {
                        new System.Data.Common.DataColumnMapping("GlobalCostCategoryId", "GlobalCostCategoryId"),
                        new System.Data.Common.DataColumnMapping("Name", "Name")})} );
            // 
            // oleDbSelectCommand5
            // 
            this.oleDbSelectCommand5.CommandText = resources.GetString( "oleDbSelectCommand5.CommandText" );
            this.oleDbSelectCommand5.Connection = this.oleDbConnection1;
            // 
            // daEmplCostParent
            // 
            this.daEmplCostParent.SelectCommand = this.oleDbSelectCommand5;
            this.daEmplCostParent.TableMappings.AddRange( new System.Data.Common.DataTableMapping[] {
            new System.Data.Common.DataTableMapping("Table", "Employee", new System.Data.Common.DataColumnMapping[] {
                        new System.Data.Common.DataColumnMapping("OrgUnitId", "OrgUnitId"),
                        new System.Data.Common.DataColumnMapping("Name", "Name"),
                        new System.Data.Common.DataColumnMapping("PersNr", "PersNr"),
                        new System.Data.Common.DataColumnMapping("FirstName", "FirstName"),
                        new System.Data.Common.DataColumnMapping("IsActive", "IsActive"),
                        new System.Data.Common.DataColumnMapping("Department", "Department"),
                        new System.Data.Common.DataColumnMapping("Client", "Client")})} );
            // 
            // dsEmplCost1
            // 
            this.dsEmplCost1.DataSetName = "DSEmplCost";
            this.dsEmplCost1.EnforceConstraints = false;
            this.dsEmplCost1.SchemaSerializationMode = System.Data.SchemaSerializationMode.IncludeSchema;
            ( (System.ComponentModel.ISupportInitialize)( this.dsEmplCost1 ) ).EndInit();

        }

        // ------------------------------------------------------------------------------------------
        // Daten laden und Grid.DataSource initialisieren
        // ------------------------------------------------------------------------------------------
        private void InitData()
        {
            try
            {
                // Combobox Mandant
                // ----------------
                this.daClient.Fill( this.dsEmplCost1, "OrgUnitClient" );
                this.cbClient.DataSource = this.dsEmplCost1.Tables["OrgUnitClient"];

                // Combobox Employment
                // -------------------
                this.cbEmployment.DataSource = EmploymentOptionTable();

                // Combobox Aktions-Optionen
                // -------------------------
                this.cbActionOption.DataSource = ActionOptionTable();

                // Comboboxen Kostenkategorien (für Suche und Aktion)
                // -------------------------------------------------
                this.dsGlobalCost1 = new DSGlobalCost();
                this.dsGlobalCost1.EnforceConstraints = false;
                this.daGlobalCost.Fill( this.dsGlobalCost1, globalCostTable );
                this.cbSearchCost.DataSource = CostCategoryTable();
                this.cbActionCost.DataSource = CostCategoryTable();

                // Comboboxen Pauschalkosten (für Suche und Aktionen)
                // -------------------------------------------------
                this.daGlobalAddOnCost.Fill( this.dsGlobalCost1, globalAddOnCostTable );
                this.cbSearchAddOnCost.DataSource = CostAddOnTable();
                this.cbActionAddOnCost.DataSource = CostAddOnTable();

                // Tabelle EmplCost
                // ----------------
                if ( pageContext.HasSearchSelection && !Page.IsPostBack )
                {
                    // Suchauswahl wird nicht restored (Suchart, Suchmuster nicht im Kontext)
                    pageContext.SelectParentCmd = "";
                    pageContext.HasSearchSelection = false;
                }
                this.daEmplCostParent.SelectCommand.CommandText = pageContext.SelectParentCmd;
                if ( daEmplCostParent.SelectCommand.CommandText.Length > 0 )
                {
                    this.daEmplCostParent.Fill( dsEmplCost1.Employee );
                    this.daEmplCostChild.Fill( dsEmplCost1.MIS_EmplCost );
                }

                this.grid.DataSource = this.dsEmplCost1.Employee;
                this.grid.DataBind();

                // Nächster freier Primary Key 
                emplCostKey = MIS_Base.MTableKey.ReadNextKey( childTable );

            }
            catch ( Exception x )
            {
                new ErrorLogger().LogError( x );
                this.lblError.Text = ErrorLogger.StandardCommonErrorMsg;
            }

        }

        // ------------------------------------------------------------------------------------------
        // Init Layout Tabelle EmplCost
        // ------------------------------------------------------------------------------------------
        protected void grid_InitializeLayout( object sender, Infragistics.WebUI.UltraWebGrid.LayoutEventArgs e )
        {
            if ( !Page.IsPostBack )
            {
                // Grid Layout
                // -----------
                // Load Style-Preset
                grid.LoadPreset( this.Page.MapPath( "./Styles/GridHierarchical_OfficeSilver.xml" ), true );
                grid.DisplayLayout.ViewType = ViewType.Hierarchical;
                grid.DisplayLayout.RowSelectorsDefault = RowSelectors.Yes;

                // Settings, welche ev. noch in das Style-Preset integriert werden können
                grid.DisplayLayout.RowExpAreaStyleDefault.BackColor = Color.White;
                grid.DisplayLayout.RowAlternateStylingDefault = Infragistics.WebUI.Shared.DefaultableBoolean.True;
                grid.DisplayLayout.RowAlternateStyleDefault.BackColor = Color.WhiteSmoke;
                grid.DisplayLayout.AllowColSizingDefault = AllowSizing.Fixed;
                grid.DisplayLayout.AllowColumnMovingDefault = AllowColumnMoving.None;
                grid.DisplayLayout.RowSizingDefault = AllowSizing.Fixed;

                // Grid Grösse
                grid.Height = Unit.Pixel( 400 );
                grid.Width = Unit.Percentage( 95 );
                // Add Box ohne Prompt und flache Darstellung der Buttons
                grid.DisplayLayout.AddNewBox.Prompt = "";
                grid.DisplayLayout.AddNewBox.View = AddNewBoxView.Compact;
                // Cell-Click --> edit mode
                grid.DisplayLayout.CellClickActionDefault = CellClickAction.Edit;

                // BAND[0] Settings (Employees)
                // ---------------------------
                grid.Bands[0].BaseTableName = parentTable;
                grid.Bands[0].DataKeyField = "OrgUnitId";
                grid.Bands[0].AllowUpdate = AllowUpdate.No;
                grid.Bands[0].AllowDelete = AllowDelete.No;
                grid.Bands[0].AllowAdd = AllowAddNew.No;
                // Id - Spalte
                grid.Bands[0].Columns.FromKey( "OrgUnitId" ).Hidden = true;
                grid.Bands[0].Columns.FromKey( "OrgUnitId" ).Width = Unit.Percentage( 0 );
                // Übrige DB - Spalten
                grid.Bands[0].Columns.FromKey( "Name" ).Move( 0 );
                grid.Bands[0].Columns.FromKey( "Name" ).Header.Caption = "Name";
                grid.Bands[0].Columns.FromKey( "Name" ).Width = Unit.Percentage( 20 );
                grid.Bands[0].Columns.FromKey( "Firstname" ).Move( 1 );
                grid.Bands[0].Columns.FromKey( "Firstname" ).Header.Caption = "Vorname";
                grid.Bands[0].Columns.FromKey( "Firstname" ).Width = Unit.Percentage( 20 );
                grid.Bands[0].Columns.FromKey( "PersNr" ).Move( 2 );
                grid.Bands[0].Columns.FromKey( "PersNr" ).Header.Caption = "Pers.Nr.";
                grid.Bands[0].Columns.FromKey( "PersNr" ).Width = Unit.Percentage( 10 );
                grid.Bands[0].Columns.FromKey( "IsActive" ).Move( 3 );
                grid.Bands[0].Columns.FromKey( "IsActive" ).Header.Style.HorizontalAlign = HorizontalAlign.Center;
                grid.Bands[0].Columns.FromKey( "IsActive" ).Header.Caption = "Aktiv";
                grid.Bands[0].Columns.FromKey( "IsActive" ).Width = Unit.Percentage( 10 );
                grid.Bands[0].Columns.FromKey( "IsActive" ).Type = ColumnType.CheckBox;
                grid.Bands[0].Columns.FromKey( "IsActive" ).CellStyle.HorizontalAlign = HorizontalAlign.Center;
                grid.Bands[0].Columns.FromKey( "Client" ).Move( 4 );
                grid.Bands[0].Columns.FromKey( "Client" ).Header.Caption = "Betrieb";
                grid.Bands[0].Columns.FromKey( "Client" ).Width = Unit.Percentage( 20 );
                grid.Bands[0].Columns.FromKey( "Department" ).Move( 5 );
                grid.Bands[0].Columns.FromKey( "Department" ).Header.Caption = "Abteilung";
                grid.Bands[0].Columns.FromKey( "Department" ).Width = Unit.Percentage( 20 );

                // BAND[1] Settings (EmplCost)
                // ---------------------------
                grid.Bands[1].BaseTableName = childTable;
                grid.Bands[1].DataKeyField = "EmplCostId";
                grid.Bands[1].AddButtonCaption = "Neues Gültig ab";
                grid.Bands[1].AllowUpdate = AllowUpdate.Yes;
                grid.Bands[1].AllowDelete = AllowDelete.Yes;
                grid.Bands[1].AllowAdd = AllowAddNew.Yes;
                // Datum - Spalte
                this.edValidDate.Visible = true;
                grid.Bands[1].Columns.FromKey( "ValidFrom" ).Move( 0 );
                grid.Bands[1].Columns.FromKey( "ValidFrom" ).Header.Caption = "Gültig ab";
                grid.Bands[1].Columns.FromKey( "ValidFrom" ).Width = Unit.Percentage( 10 );
                grid.Bands[1].Columns.FromKey( "ValidFrom" ).Format = "dd.mm.yyyy";
                grid.Bands[1].Columns.FromKey( "ValidFrom" ).Type = ColumnType.Custom;
                grid.Bands[1].Columns.FromKey( "ValidFrom" ).EditorControlID = this.edValidDate.UniqueID;
                // StundenBasis - Spalte
                grid.Bands[1].Columns.FromKey( "HourBase" ).Move( 1 );
                grid.Bands[1].Columns.FromKey( "HourBase" ).Header.Caption = "Std. Basis";
                grid.Bands[1].Columns.FromKey( "HourBase" ).Header.Style.HorizontalAlign = HorizontalAlign.Right;
                grid.Bands[1].Columns.FromKey( "HourBase" ).Header.Style.Padding.Right = Unit.Pixel( 3 );
                grid.Bands[1].Columns.FromKey( "HourBase" ).Width = Unit.Percentage( 10 );
                grid.Bands[1].Columns.FromKey( "HourBase" ).CellStyle.HorizontalAlign = HorizontalAlign.Right;
                grid.Bands[1].Columns.FromKey( "HourBase" ).CellStyle.Padding.Right = Unit.Pixel( 3 );
                // Kosten Typ - Spalte (CB-Spalte)
                grid.Bands[1].Columns.FromKey( "CostType" ).Move( 2 );
                grid.Bands[1].Columns.FromKey( "CostType" ).Header.Caption = "Kostenpflege";
                grid.Bands[1].Columns.FromKey( "CostType" ).Width = Unit.Percentage( 16 );
                grid.Bands[1].Columns.FromKey( "CostType" ).Type = ColumnType.DropDownList;
                grid.Bands[1].Columns.FromKey( "CostType" ).ValueList = CostTypeList();
                // Sperre Kosten - Spalte (Checkbox)
                grid.Bands[1].Columns.FromKey( "CostLocked" ).Move( 3 );
                grid.Bands[1].Columns.FromKey( "CostLocked" ).Header.Caption = "Sperre";
                grid.Bands[1].Columns.FromKey( "CostLocked" ).Header.Style.HorizontalAlign = HorizontalAlign.Center;
                grid.Bands[1].Columns.FromKey( "CostLocked" ).Width = Unit.Percentage( 7 ); ;
                grid.Bands[1].Columns.FromKey( "CostLocked" ).CellStyle.HorizontalAlign = HorizontalAlign.Center;
                grid.Bands[1].Columns.FromKey( "CostLocked" ).Type = ColumnType.CheckBox;
                // Kosten/Std - Spalte
                grid.Bands[1].Columns.FromKey( "HourCost" ).Move( 4 );
                grid.Bands[1].Columns.FromKey( "HourCost" ).Header.Caption = "Kosten/Std.";
                grid.Bands[1].Columns.FromKey( "HourCost" ).Header.Style.HorizontalAlign = HorizontalAlign.Right;
                grid.Bands[1].Columns.FromKey( "HourCost" ).Header.Style.Padding.Right = Unit.Pixel( 3 );
                grid.Bands[1].Columns.FromKey( "HourCost" ).Width = Unit.Percentage( 10 );
                grid.Bands[1].Columns.FromKey( "HourCost" ).CellStyle.HorizontalAlign = HorizontalAlign.Right;
                grid.Bands[1].Columns.FromKey( "HourCost" ).CellStyle.Padding.Right = Unit.Pixel( 3 );
                // Globale Kostenkategorie - Spalte (CB-Spalte)
                grid.Bands[1].Columns.FromKey( "GlobalCostCategoryId" ).Move( 5 );
                grid.Bands[1].Columns.FromKey( "GlobalCostCategoryId" ).Header.Caption = "Kostenkategorie";
                grid.Bands[1].Columns.FromKey( "GlobalCostCategoryId" ).Width = Unit.Percentage( 15 );
                grid.Bands[1].Columns.FromKey( "GlobalCostCategoryId" ).Type = ColumnType.DropDownList;
                grid.Bands[1].Columns.FromKey( "GlobalCostCategoryId" ).ValueList = CostCategoryList();
                grid.Bands[1].Columns.FromKey( "GlobalCostCategoryId" ).NullText = "(keine)";
                // Sperre Pauschalkosten - Spalte (Checkbox)
                grid.Bands[1].Columns.FromKey( "AddOnLocked" ).Move( 6 );
                grid.Bands[1].Columns.FromKey( "AddOnLocked" ).Header.Caption = "Sperre";
                grid.Bands[1].Columns.FromKey( "AddOnLocked" ).Header.Style.HorizontalAlign = HorizontalAlign.Center;
                grid.Bands[1].Columns.FromKey( "AddOnLocked" ).Width = Unit.Percentage( 7 ); ;
                grid.Bands[1].Columns.FromKey( "AddOnLocked" ).CellStyle.HorizontalAlign = HorizontalAlign.Center;
                grid.Bands[1].Columns.FromKey( "AddOnLocked" ).Type = ColumnType.CheckBox;
                // Pauschalkosten/Std - Spalte
                grid.Bands[1].Columns.FromKey( "AddOnHourCost" ).Move( 7 );
                grid.Bands[1].Columns.FromKey( "AddOnHourCost" ).Header.Caption = "Pauschal/Std.";
                grid.Bands[1].Columns.FromKey( "AddOnHourCost" ).Header.Style.HorizontalAlign = HorizontalAlign.Right;
                grid.Bands[1].Columns.FromKey( "AddOnHourCost" ).Header.Style.Padding.Right = Unit.Pixel( 3 );
                grid.Bands[1].Columns.FromKey( "AddOnHourCost" ).Width = Unit.Percentage( 10 );
                grid.Bands[1].Columns.FromKey( "AddOnHourCost" ).CellStyle.HorizontalAlign = HorizontalAlign.Right;
                grid.Bands[1].Columns.FromKey( "AddOnHourCost" ).CellStyle.Padding.Right = Unit.Pixel( 3 );
                // Globale Pauschalkosten - Spalte (CB-Spalte)
                grid.Bands[1].Columns.FromKey( "GlobalCostAddOnId" ).Move( 8 );
                grid.Bands[1].Columns.FromKey( "GlobalCostAddOnId" ).Header.Caption = "Globale Pauschalkosten";
                grid.Bands[1].Columns.FromKey( "GlobalCostAddOnId" ).Width = Unit.Percentage( 15 );
                grid.Bands[1].Columns.FromKey( "GlobalCostAddOnId" ).Type = ColumnType.DropDownList;
                grid.Bands[1].Columns.FromKey( "GlobalCostAddOnId" ).ValueList = CostAddOnList();
                grid.Bands[1].Columns.FromKey( "GlobalCostAddOnId" ).NullText = "(keine)";
                // Id-Spalten
                grid.Bands[1].Columns.FromKey( "EmplCostId" ).Hidden = true; ;
                grid.Bands[1].Columns.FromKey( "EmplCostId" ).Width = Unit.Percentage( 0 );
                grid.Bands[1].Columns.FromKey( "OrgUnitId" ).Hidden = true;
                grid.Bands[1].Columns.FromKey( "OrgUnitId" ).Width = Unit.Percentage( 0 );

                // User Rights
                // -----------
                SetupGridRights( (MIS_Domain.MUser)Session["USER"] );
            }
        }

        // ------------------------------------------------------------------------------------------
        //  Grid best. Spalten initialisieren
        // ------------------------------------------------------------------------------------------
        protected void grid_InitializeRow( object sender, RowEventArgs e )
        {
            if ( e.Row.Band.Key.Equals(childTable) )
            {
                // Bei Kostenpflege 'Import-Lohn' werden alle Spalten disabled
                if ( e.Row.Cells.FromKey( "CostType" ).Value.ToString().Equals( ( (int)MECostType.ImportStandard ).ToString() ) )
                {
                    // keine Sperre
                    e.Row.Cells.FromKey( "CostLocked" ).Value = 0;
                    e.Row.Cells.FromKey( "AddOnLocked" ).Value = 0;
                    // enable / disable
                    e.Row.Cells.FromKey( "ValidFrom" ).AllowEditing = AllowEditing.No;
                    e.Row.Cells.FromKey( "HourBase" ).AllowEditing = AllowEditing.No;
                    e.Row.Cells.FromKey( "CostLocked" ).AllowEditing = AllowEditing.No;
                    e.Row.Cells.FromKey( "HourCost" ).AllowEditing = AllowEditing.No;
                    e.Row.Cells.FromKey( "GlobalCostCategoryId" ).AllowEditing = AllowEditing.No;
                    e.Row.Cells.FromKey( "AddOnLocked" ).AllowEditing = AllowEditing.No;
                    e.Row.Cells.FromKey( "AddOnHourCost" ).AllowEditing = AllowEditing.No;
                    e.Row.Cells.FromKey( "GlobalCostAddOnId" ).AllowEditing = AllowEditing.No;
                }
                else
                {
                    // Bei Zuordnung globaler Kosten sind Werte gesperrt
                    if ( e.Row.Cells.FromKey( "GlobalCostCategoryId" ).Value != null )
                        e.Row.Cells.FromKey( "HourCost" ).AllowEditing = AllowEditing.No;
                    if ( e.Row.Cells.FromKey( "GlobalCostAddOnId" ).Value != null )
                        e.Row.Cells.FromKey( "AddOnHourCost" ).AllowEditing = AllowEditing.No;
                }
            }

        }

        // ------------------------------------------------------------------------------------------
        //  Values-List für Kostentyp CB
        // ------------------------------------------------------------------------------------------
        private ValueList CostCategoryList()
        {
            ValueList valList = new ValueList( true );
            valList.ValueListItems.Add( 0, "(keine)" );
            for ( int i=0; i < this.dsGlobalCost1.Tables[globalCostTable].Rows.Count; i++ )
            {
                DataRow row = this.dsGlobalCost1.Tables[globalCostTable].Rows[i];
                valList.ValueListItems.Add( (int)row["GlobalCostCategoryId"], row["Name"].ToString() );
            }
            return valList;
        }
        private DataTable CostCategoryTable()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add( "Value", System.Type.GetType( "System.Int32" ) );
            dt.Columns.Add( "Desc", System.Type.GetType( "System.String" ) );
            DataRow dr = dt.NewRow();
            dr["Value"] = DBNull.Value;
            dr["Desc"] = "(keine)";
            dt.Rows.Add( dr );
            for ( int i=0; i < this.dsGlobalCost1.Tables[globalCostTable].Rows.Count; i++ )
            {
                dr = dt.NewRow();
                dr["Value"] = this.dsGlobalCost1.Tables[globalCostTable].Rows[i]["GlobalCostCategoryId"];
                dr["Desc"] = this.dsGlobalCost1.Tables[globalCostTable].Rows[i]["Name"].ToString();
                dt.Rows.Add( dr );
            }
            return dt;
        }

        // ------------------------------------------------------------------------------------------
        //  Values-List für Kostentyp CB
        // ------------------------------------------------------------------------------------------
        private ValueList CostAddOnList()
        {
            ValueList valList = new ValueList( true );
            valList.ValueListItems.Add( 0, "(keine)" );
            for ( int i=0; i < this.dsGlobalCost1.Tables[globalAddOnCostTable].Rows.Count; i++ )
            {
                DataRow row = this.dsGlobalCost1.Tables[globalAddOnCostTable].Rows[i];
                valList.ValueListItems.Add( (int)row["GlobalCostAddOnId"], row["Name"].ToString() );
            }
            return valList;
        }

        private DataTable CostAddOnTable()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add( "Value", System.Type.GetType( "System.Int32" ) );
            dt.Columns.Add( "Desc", System.Type.GetType( "System.String" ) );
            DataRow dr = dt.NewRow();
            dr["Value"] = DBNull.Value;
            dr["Desc"] = "(keine)";
            dt.Rows.Add( dr );
            for ( int i=0; i < this.dsGlobalCost1.Tables[globalAddOnCostTable].Rows.Count; i++ )
            {
                dr = dt.NewRow();
                dr["Value"] = this.dsGlobalCost1.Tables[globalAddOnCostTable].Rows[i]["GlobalCostAddOnId"];
                dr["Desc"] = this.dsGlobalCost1.Tables[globalAddOnCostTable].Rows[i]["Name"].ToString();
                dt.Rows.Add( dr );
            }
            return dt;
        }

        // ------------------------------------------------------------------------------------------
        //  Values-List für Kostentyp CB
        // ------------------------------------------------------------------------------------------
        private ValueList CostTypeList()
        {
            // In der DB sind nur diese Enum-Werte gespeichert. Die übrigen Werte definieren nur beim
            // Importablauf das Verhalten !!!
            ValueList valList = new ValueList( true );
            valList.ValueListItems.Add( Convert.ToInt16(MECostType.ManualCostCare), "Manuell" );
            valList.ValueListItems.Add( Convert.ToInt16(MECostType.ImportStandard), "Import-Lohn" );
            return valList;
        }

        // ------------------------------------------------------------------------------------------
        //  Values-List für Anstellungs Varianten
        // ------------------------------------------------------------------------------------------
        private DataTable EmploymentOptionTable()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add( "Value", System.Type.GetType( "System.Int32" ) );
            dt.Columns.Add( "Desc", System.Type.GetType( "System.String" ) );
            DataRow dr = dt.NewRow();
            dr["Value"] = (int)MEEmploymentOptions.All;
            dr["Desc"] = "Alle";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEEmploymentOptions.HourIncomeOnly;
            dr["Desc"] = "nur Stundenlohn";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEEmploymentOptions.HourIncomeOnce;
            dr["Desc"] = "mit Stundenlohn";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEEmploymentOptions.DayNomTimeOnly;
            dr["Desc"] = "nur Tagessollzeit";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEEmploymentOptions.DayNomTimeOnce;
            dr["Desc"] = "mit Tagessollzeit";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEEmploymentOptions.MonthNomTimeOnly;
            dr["Desc"] = "nur Monatssollzeit";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEEmploymentOptions.MonthNomTimeOnce;
            dr["Desc"] = "mit Monatssollzeit";
            dt.Rows.Add( dr );
            return dt;
        }

        // ------------------------------------------------------------------------------------------
        //  Values-List für Optionenliste Aktionen
        // ------------------------------------------------------------------------------------------
        private DataTable ActionOptionTable()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add( "Value", System.Type.GetType( "System.Int32" ) );
            dt.Columns.Add( "Desc", System.Type.GetType( "System.String" ) );
            DataRow dr = dt.NewRow();
            dr["Value"] = (int)MEActionOptions.ForAllValidDates;
            dr["Desc"] = "Für alle gültig ab";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEActionOptions.RefDateUpdate;
            dr["Desc"] = "Am Stichdatum aktualisieren";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEActionOptions.RefDateInsert;
            dr["Desc"] = "Am Stichdatum einfügen / aktualisieren";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEActionOptions.RefDateDelete;
            dr["Desc"] = "Am Stichdatum löschen";
            dt.Rows.Add( dr );
            dr = dt.NewRow();
            dr["Value"] = (int)MEActionOptions.DeleteAllValidDates;
            dr["Desc"] = "Alle Gültig ab löschen";
            dt.Rows.Add( dr );
            return dt;
        }

        // ------------------------------------------------------------------------------------------
        // Mandant CB : Init Layout
        // ------------------------------------------------------------------------------------------
        protected void cbClient_InitializeLayout( object sender, Infragistics.WebUI.UltraWebGrid.LayoutEventArgs e )
        {
            WebCombo_InitializeLayout( this.cbClient, "Name", "OrgUnitId" );
        }

        // ------------------------------------------------------------------------------------------
        // Employment Options CB : Init Layout
        // ------------------------------------------------------------------------------------------
        protected void cbEmployment_InitializeLayout( object sender, LayoutEventArgs e )
        {
            WebCombo_InitializeLayout( this.cbEmployment, "Desc", "Value" );
        }

        // ------------------------------------------------------------------------------------------
        // Aktionen Options CB : Init Layout
        // ------------------------------------------------------------------------------------------
        protected void cbActionOption_InitializeLayout( object sender, LayoutEventArgs e )
        {
            WebCombo_InitializeLayout( this.cbActionOption, "Desc", "Value" );
        }

        // ------------------------------------------------------------------------------------------
        // Init Layout CB - Globale Kostenkategorien
        // ------------------------------------------------------------------------------------------
        protected void cbActionCost_InitializeLayout( object sender, Infragistics.WebUI.UltraWebGrid.LayoutEventArgs e )
        {
            WebCombo_InitializeLayout( this.cbActionCost, "Desc", "Value" );
        }

        // ------------------------------------------------------------------------------------------
        // Init Layout CB - Globale Pauschalkosten
        // ------------------------------------------------------------------------------------------
        protected void cbActionAddOnCost_InitializeLayout( object sender, Infragistics.WebUI.UltraWebGrid.LayoutEventArgs e )
        {
            WebCombo_InitializeLayout( this.cbActionAddOnCost, "Desc", "Value" ); 
        }

        // ------------------------------------------------------------------------------------------
        // Init Layout CB - Suche nach Kostenkategorie
        // ------------------------------------------------------------------------------------------
        protected void cbSearchCost_InitializeLayout( object sender, LayoutEventArgs e )
        {
            WebCombo_InitializeLayout( this.cbSearchCost, "Desc", "Value" ); 
        }

        // ------------------------------------------------------------------------------------------
        // Init Layout CB - Suche nach Pauschalkosten Kategorie
        // ------------------------------------------------------------------------------------------
        protected void cbSearchAddOnCost_InitializeLayout( object sender, LayoutEventArgs e )
        {
            WebCombo_InitializeLayout( this.cbSearchAddOnCost, "Desc", "Value" ); 
        }

        // ------------------------------------------------------------------------------------------
        // InitLayout für ungebundene Standard WebCombo mit den Spalten 'Value' und 'Desc'
        // ------------------------------------------------------------------------------------------
        private void WebCombo_InitializeLayout( Infragistics.WebUI.WebCombo.WebCombo cb, 
            string textField, string valueField )
        {
            // Als erstes immer Preset laden
            //cb.LoadPreset( this.Page.MapPath( "./Styles/MISWebCombo_NoHeader.xml" ), true );
            // Data Properties
            cb.DataTextField = textField;
            cb.DataValueField = valueField;
            // Layout Properties
            cb.DropDownLayout.ColHeadersVisible = Infragistics.WebUI.UltraWebGrid.ShowMarginInfo.No;
            cb.DropDownLayout.RowSelectors = Infragistics.WebUI.UltraWebGrid.RowSelectors.No;
            // Spalten-Layout
            cb.Columns.FromKey( valueField ).Width = Unit.Percentage( 0 );
            cb.Columns.FromKey( valueField ).Hidden = true;
            cb.Columns.FromKey( textField ).Width = Unit.Percentage( 100 );
        }

        // ------------------------------------------------------------------------------------------
        // Die Auswahl des Mandanten hat geändert
        // ------------------------------------------------------------------------------------------
        protected void cbClient_SelectedRowChanged( object sender, Infragistics.WebUI.WebCombo.SelectedRowChangedEventArgs e )
        {
            // Organisation für den ausgewählten Mandanten laden
            MOrgClient clientNode = new MOrgClient( new MOrgNodeInfo( Convert.ToInt32(cbClient.DataValue), cbClient.DisplayValue ) );
            LoadOrgTree( clientNode );
            // Init DataAdapter Select-Command
            new MOrgBroker().InitSearchByOrgCmd( this.daEmplCostParent.SelectCommand, Convert.ToInt32( cbClient.DataValue ),
                0, this.checkInactiveEmpl.Checked, (MEEmploymentOptions)this.cbEmployment.SelectedIndex );
            pageContext.SelectParentCmd = daEmplCostParent.SelectCommand.CommandText;
            pageContext.HasSearchSelection = false;
            // Load Data
            LoadEmplCost();
        }

        // ------------------------------------------------------------------------------------------
        // Die Auswahl der Organisation hat geändert
        // ------------------------------------------------------------------------------------------
        protected void orgTree_NodeSelectionChanged( object sender, Infragistics.WebUI.UltraWebNavigator.WebTreeNodeEventArgs e )
        {
            // Clear Suchfelder
            ClearSearchFields( sender );
            // Init DataAdapter Select-Command
            new MOrgBroker().InitSearchByOrgCmd( this.daEmplCostParent.SelectCommand, Convert.ToInt32( cbClient.DataValue ),
                Convert.ToInt32(this.orgTree.SelectedNode.Tag), this.checkInactiveEmpl.Checked, 
                (MEEmploymentOptions)this.cbEmployment.SelectedIndex );
            pageContext.SelectParentCmd = daEmplCostParent.SelectCommand.CommandText;
            pageContext.HasSearchSelection = false;
            // Load Data
            LoadEmplCost();
        }

        // ------------------------------------------------------------------------------------------
        // Suchen nach PersNr
        // ------------------------------------------------------------------------------------------
        protected void BtnSearchByPNr_Click( object sender, ImageClickEventArgs e )
        {
            if ( this.cbClient.SelectedIndex >= 0 )
            {
                // Clear Suchfelder
                ClearSearchFields( sender );
                // Init DataAdapter Select-Command
                new MOrgBroker().InitSearchByPNrCmd( this.daEmplCostParent.SelectCommand, 
                    Convert.ToInt32( cbClient.DataValue ), this.edSearchPersNr.Text, this.checkInactiveEmpl.Checked );
                pageContext.SelectParentCmd = daEmplCostParent.SelectCommand.CommandText;
                pageContext.HasSearchSelection = true;
                // Load Data
                LoadEmplCost();
            }
            else
                this.lblError.Text = "Bitte wählen Sie einen Mandanten aus.";
        }

        // ------------------------------------------------------------------------------------------
        // Suchen nach Name
        // ------------------------------------------------------------------------------------------
        protected void BtnSearchByName_Click( object sender, ImageClickEventArgs e )
        {
            if ( this.cbClient.SelectedIndex >= 0 )
            {
                // Clear Suchfelder
                ClearSearchFields( sender );
                // Init DataAdapter Select-Command
                new MOrgBroker().InitSearchByNameCmd( this.daEmplCostParent.SelectCommand,
                    Convert.ToInt32( cbClient.DataValue ), this.edSearchName.Text, this.checkInactiveEmpl.Checked );
                pageContext.SelectParentCmd = daEmplCostParent.SelectCommand.CommandText;
                pageContext.HasSearchSelection = true;
                // Load Data
                LoadEmplCost();
            }
            else
                this.lblError.Text = "Bitte wählen Sie einen Mandanten aus.";
        }

        // ------------------------------------------------------------------------------------------
        // Suchen nach Kostenwert
        // ------------------------------------------------------------------------------------------
        protected void BtnSearchByCost_Click( object sender, ImageClickEventArgs e )
        {
            if ( this.cbClient.SelectedIndex >= 0 && this.cbSearchCost.SelectedIndex >= 0 )
            {
                // Clear Suchfelder
                ClearSearchFields( sender );
                // Init DataAdapter Select-Command
                int costId = 0;
                try
                {
                costId = Convert.ToInt32( this.cbSearchCost.DataValue );
                }
                catch(Exception)
                {
                }
                new MOrgBroker().InitSearchByCostCmd( this.daEmplCostParent.SelectCommand,
                    Convert.ToInt32( cbClient.DataValue ), costId, this.checkInactiveEmpl.Checked );
                pageContext.SelectParentCmd = daEmplCostParent.SelectCommand.CommandText;
                pageContext.HasSearchSelection = true;
                // Load Data
                LoadEmplCost();
            }
            else
                this.lblError.Text = "Fehlende Auswahl (Mandant oder Kosten-Kategorie)";
        }

        // ------------------------------------------------------------------------------------------
        // Suchen nach Pauschal-Kostenwert
        // ------------------------------------------------------------------------------------------
        protected void BtnSearchByAddOnCost_Click( object sender, ImageClickEventArgs e )
        {
            if ( this.cbClient.SelectedIndex >= 0 && this.cbSearchAddOnCost.SelectedIndex >= 0 )
            {
                // Clear Suchfelder
                ClearSearchFields( sender );
                // Init DataAdapter Select-Command
                int addOnCostId = 0;
                try
                {
                    addOnCostId = Convert.ToInt32( this.cbSearchAddOnCost.DataValue );
                }
                catch ( Exception )
                {
                }
                new MOrgBroker().InitSearchByAddOnCostCmd( this.daEmplCostParent.SelectCommand,
                    Convert.ToInt32( cbClient.DataValue ), addOnCostId, this.checkInactiveEmpl.Checked );
                pageContext.SelectParentCmd = daEmplCostParent.SelectCommand.CommandText;
                pageContext.HasSearchSelection = true;
                // Load Data
                LoadEmplCost();
            }
            else
                this.lblError.Text = "Fehlende Auswahl (Mandant oder Pauschalkosten-Kategorie)";
        }

        // ------------------------------------------------------------------------------------------
        // Suchen nach MA ohne Kostenzuordnung
        // ------------------------------------------------------------------------------------------
        protected void BtnSearchByEmplNoCost_Click( object sender, ImageClickEventArgs e )
        {
            if ( this.cbClient.SelectedIndex >= 0 )
            {
                // Clear Suchfelder
                ClearSearchFields( sender );
                // Init DataAdapter Select-Command
                new MOrgBroker().InitSearchByNoEmplCostCmd( this.daEmplCostParent.SelectCommand,
                    Convert.ToInt32( cbClient.DataValue ), this.checkInactiveEmpl.Checked );
                pageContext.SelectParentCmd = daEmplCostParent.SelectCommand.CommandText;
                pageContext.HasSearchSelection = true;
                // Load Data
                LoadEmplCost();
            }
            else
                this.lblError.Text = "Bitte wählen Sie einen Mandanten aus.";
        }

        // ------------------------------------------------------------------------------------------
        // Aktion : Kostenkategorie übernehmen
        // ------------------------------------------------------------------------------------------
        protected void btnApplyCostCategory_Click( object sender, EventArgs e )
        {
            if ( this.cbActionOption.SelectedIndex >= 0 && this.cbActionCost.SelectedIndex >= 0 )
            {
                for ( int i=0; i < this.dsEmplCost1.Tables[parentTable].Rows.Count; i++ )
                {
                    MEActionOptions option = (MEActionOptions)this.cbActionOption.SelectedRow.Cells.FromKey( "Value" ).Value;
                    DataRow parentRow = this.dsEmplCost1.Tables[parentTable].Rows[i];
                    DataRow[] childRows = parentRow.GetChildRows( this.dsEmplCost1.Relations[0] );
                    DataRow insertRowTemplate = null;
                    bool done = false;

                    for ( int j=0; j < childRows.Length; j++ )
                    {
                        DataRow row = childRows[j];

                        switch ( option )
                        {
                            case MEActionOptions.ForAllValidDates:
                                row["GlobalCostCategoryId"] = this.cbActionCost.DataValue != null ? this.cbActionCost.DataValue : DBNull.Value;
                                row["HourCost"] = 0;
                                break;
                            case MEActionOptions.RefDateInsert:
                                if ( this.edActionRefDate.Value != null )
                                {
                                    if ( row["ValidFrom"].Equals( this.edActionRefDate.Value ) )
                                    {
                                        // Update best. row
                                        row["GlobalCostCategoryId"] = this.cbActionCost.DataValue != null ? this.cbActionCost.DataValue : DBNull.Value;
                                        row["HourCost"] = 0;
                                        done = true;
                                        insertRowTemplate = null;
                                    }
                                    else
                                    {
                                        insertRowTemplate = row;
                                    }
                                }
                                break;
                            case MEActionOptions.RefDateUpdate:
                                if ( this.edActionRefDate.Value != null )
                                {
                                    if ( row["ValidFrom"].Equals( this.edActionRefDate.Value ) )
                                    {
                                        row["GlobalCostCategoryId"] = this.cbActionCost.DataValue != null ? this.cbActionCost.DataValue : DBNull.Value;
                                        row["HourCost"] = 0;
                                        done = true;
                                    }
                                }
                                break;
                        }
                        if ( done )
                            break;
                    }

                    if ( option == MEActionOptions.RefDateInsert && !done )
                    {
                        // Neue Childrow mit Werte letztem ValidFrom oder mit Defaults initialisieren
                        DataRow newRow;
                        newRow = this.dsEmplCost1.Tables[childTable].NewRow();
                        newRow["EmplCostId"] = ++emplCostKey;
                        newRow["OrgUnitId"] = parentRow["OrgUnitId"];
                        newRow["GlobalCostCategoryId"] = this.cbActionCost.DataValue != null ? this.cbActionCost.DataValue : DBNull.Value;
                        newRow["GlobalCostAddOnId"] = insertRowTemplate != null ? insertRowTemplate["GlobalCostAddOnId"] : DBNull.Value;
                        newRow["ValidFrom"] = this.edActionRefDate.Value;
                        newRow["HourBase"] = insertRowTemplate != null ? insertRowTemplate["HourBase"] : 1;
                        newRow["HourCost"] = 0;
                        newRow["AddOnHourCost"] = insertRowTemplate != null ? insertRowTemplate["HourCost"] : 0; ;
                        newRow["CostLocked"] = insertRowTemplate != null ? insertRowTemplate["CostLocked"] : 0;
                        newRow["AddOnLocked"] = insertRowTemplate != null ? insertRowTemplate["AddOnLocked"] : 0;
                        newRow["CostType"] = insertRowTemplate != null ? insertRowTemplate["CostType"] : (int)MECostType.ManualCostCare;
                        // Neue Row dem Parent hinzufügen
                        this.dsEmplCost1.Tables[childTable].Rows.Add( newRow );
                    }

                }
                // Änderungen Speichern
                btnSave_Click( sender, e );
                // Reload saved data
                LoadEmplCost();
            }
            else
                lblError.Text = "Keine Auswahl Aktions-Option bzw. Kosten-Kategorie";
        }

        // ------------------------------------------------------------------------------------------
        // Aktion : Pauschalkosten übernehmen
        // ------------------------------------------------------------------------------------------
        protected void btnApplyAddOnCost_Click( object sender, EventArgs e )
        {
            if ( this.cbActionOption.SelectedIndex >= 0 && this.cbActionAddOnCost.SelectedIndex >= 0 )
            {
                for ( int i=0; i < this.dsEmplCost1.Tables[parentTable].Rows.Count; i++ )
                {
                    MEActionOptions option = (MEActionOptions)this.cbActionOption.SelectedRow.Cells.FromKey( "Value" ).Value; 
                    DataRow parentRow = this.dsEmplCost1.Tables[parentTable].Rows[i];
                    DataRow[] childRows = parentRow.GetChildRows( this.dsEmplCost1.Relations[0] );
                    DataRow insertRowTemplate = null;
                    bool done = false;

                    for ( int j=0; j < childRows.Length; j++ )
                    {
                        DataRow row = childRows[j];

                        switch ( option )
                        {
                            case MEActionOptions.ForAllValidDates:
                                row["GlobalCostAddOnId"] = this.cbActionAddOnCost.DataValue != null ? this.cbActionAddOnCost.DataValue : DBNull.Value;
                                row["AddOnHourCost"] = 0;
                                break;
                            case MEActionOptions.RefDateInsert:
                                if ( this.edActionRefDate.Value != null )
                                {
                                    if ( row["ValidFrom"].Equals( this.edActionRefDate.Value ) )
                                    {
                                        // Update best. row
                                        row["GlobalCostAddOnId"] = this.cbActionAddOnCost.DataValue != null ? this.cbActionAddOnCost.DataValue : DBNull.Value;
                                        row["AddOnHourCost"] = 0;
                                        done = true;
                                        insertRowTemplate = null;
                                    }
                                    else
                                    {
                                        insertRowTemplate = row;
                                    }
                                }
                                break;
                            case MEActionOptions.RefDateUpdate:
                                if ( this.edActionRefDate.Value != null )
                                {
                                    if ( row["ValidFrom"].Equals( this.edActionRefDate.Value ) )
                                    {
                                        row["GlobalCostAddOnId"] = this.cbActionAddOnCost.DataValue != null ? this.cbActionAddOnCost.DataValue : DBNull.Value;
                                        row["AddOnHourCost"] = 0;
                                        done = true;
                                    }
                                }
                                break;
                        }
                        if ( done )
                            break;
                    }

                    if ( option == MEActionOptions.RefDateInsert && !done )
                    {
                        // Neue Childrow mit Werte letztem ValidFrom oder mit Defaults initialisieren
                        DataRow newRow;
                        newRow = this.dsEmplCost1.Tables[childTable].NewRow();
                        newRow["EmplCostId"] = ++emplCostKey;
                        newRow["OrgUnitId"] = parentRow["OrgUnitId"];
                        newRow["GlobalCostCategoryId"] = insertRowTemplate != null ? insertRowTemplate["GlobalCostCategoryId"] : DBNull.Value;
                        newRow["GlobalCostAddOnId"] = this.cbActionAddOnCost.DataValue != null ? this.cbActionAddOnCost.DataValue : DBNull.Value;
                        newRow["ValidFrom"] = this.edActionRefDate.Value;
                        newRow["HourBase"] = insertRowTemplate != null ? insertRowTemplate["HourBase"] : 1;
                        newRow["HourCost"] = insertRowTemplate != null ? insertRowTemplate["HourCost"] : 0;
                        newRow["AddOnHourCost"] = 0;
                        newRow["CostLocked"] = insertRowTemplate != null ? insertRowTemplate["CostLocked"] : 0;
                        newRow["AddOnLocked"] = insertRowTemplate != null ? insertRowTemplate["AddOnLocked"] : 0;
                        newRow["CostType"] = insertRowTemplate != null ? insertRowTemplate["CostType"] : (int)MECostType.ManualCostCare;
                        // Neue Row dem Parent hinzufügen
                        this.dsEmplCost1.Tables[childTable].Rows.Add( newRow );
                    }

                }
                // Änderungen Speichern
                btnSave_Click( sender, e );
                // Reload saved data
                LoadEmplCost();
            
            }
            else
                lblError.Text = "Keine Auswahl Aktions-Option bzw. Pauschalkosten";
        }

        // ------------------------------------------------------------------------------------------
        // Aktion : Sperren übernehmen und Kostentyp setzen
        // ------------------------------------------------------------------------------------------
        protected void btnApplyLocked_Click( object sender, EventArgs e )
        {
            if ( this.cbActionOption.SelectedIndex >= 0 )
            {
                for ( int i=0; i < this.dsEmplCost1.Tables[parentTable].Rows.Count; i++ )
                {
                    MEActionOptions option = (MEActionOptions)this.cbActionOption.SelectedRow.Cells.FromKey( "Value" ).Value;
                    DataRow parentRow = this.dsEmplCost1.Tables[parentTable].Rows[i];
                    DataRow[] childRows = parentRow.GetChildRows( this.dsEmplCost1.Relations[0] );
                    DataRow insertRowTemplate = null;
                    bool done = false;

                    for ( int j=0; j < childRows.Length; j++ )
                    {
                        DataRow row = childRows[j];

                        switch ( option )
                        {
                            case MEActionOptions.ForAllValidDates:
                                row["CostLocked"] = this.checkActionCostLock.Checked;
                                row["AddOnLocked"] = this.checkActionAddOnCostLock.Checked;
                                row["CostType"] = ( this.checkActionCostLock.Checked || this.checkActionAddOnCostLock.Checked ) ?
                                    (int)MECostType.ManualCostCare : (int)MECostType.ImportStandard;
                                break;
                            case MEActionOptions.RefDateInsert:
                                if ( this.edActionRefDate.Value != null )
                                {
                                    if ( row["ValidFrom"].Equals( this.edActionRefDate.Value ) )
                                    {
                                        // Update best. row
                                        row["CostLocked"] = this.checkActionCostLock.Checked;
                                        row["AddOnLocked"] = this.checkActionAddOnCostLock.Checked;
                                        row["CostType"] = ( this.checkActionCostLock.Checked || this.checkActionAddOnCostLock.Checked ) ?
                                            (int)MECostType.ManualCostCare : (int)MECostType.ImportStandard;
                                        done = true;
                                        insertRowTemplate = null;
                                    }
                                    else
                                    {
                                        insertRowTemplate = row;
                                    }
                                }
                                break;
                            case MEActionOptions.RefDateUpdate:
                                if ( this.edActionRefDate.Value != null )
                                {
                                    if ( row["ValidFrom"].Equals( this.edActionRefDate.Value ) )
                                    {
                                        row["CostLocked"] = this.checkActionCostLock.Checked;
                                        row["AddOnLocked"] = this.checkActionAddOnCostLock.Checked;
                                        row["CostType"] = ( this.checkActionCostLock.Checked || this.checkActionAddOnCostLock.Checked ) ?
                                            (int)MECostType.ManualCostCare : (int)MECostType.ImportStandard;
                                        done = true;
                                    }
                                }
                                break;
                        }
                        if ( done )
                            break;
                    }

                    if ( option == MEActionOptions.RefDateInsert && !done )
                    {
                        // Neue Childrow mit Werte letztem ValidFrom oder mit Defaults initialisieren
                        DataRow newRow;
                        newRow = this.dsEmplCost1.Tables[childTable].NewRow();
                        newRow["EmplCostId"] = ++emplCostKey;
                        newRow["OrgUnitId"] = parentRow["OrgUnitId"];
                        newRow["GlobalCostCategoryId"] = insertRowTemplate != null ? insertRowTemplate["GlobalCostCategoryId"] : DBNull.Value;
                        newRow["GlobalCostAddOnId"] = insertRowTemplate != null ? insertRowTemplate["GlobalCostAddOnId"] : DBNull.Value;
                        newRow["ValidFrom"] = this.edActionRefDate.Value;
                        newRow["HourBase"] = insertRowTemplate != null ? insertRowTemplate["HourBase"] : 1;
                        newRow["HourCost"] = insertRowTemplate != null ? insertRowTemplate["HourCost"] : 0;
                        newRow["AddOnHourCost"] = insertRowTemplate != null ? insertRowTemplate["AddOnHourCost"] : 0; ;
                        newRow["CostLocked"] = this.checkActionCostLock.Checked;
                        newRow["AddOnLocked"] = this.checkActionAddOnCostLock.Checked;
                        newRow["CostType"] = ( this.checkActionCostLock.Checked || this.checkActionAddOnCostLock.Checked ) ?
                                            (int)MECostType.ManualCostCare : (int)MECostType.ImportStandard;
                        // Neue Child-Row der Parent-Row hinzufügen
                        this.dsEmplCost1.Tables[childTable].Rows.Add( newRow );
                    }

                }
                // Änderungen Speichern
                btnSave_Click( sender, e );
                // Reload saved data
                LoadEmplCost();
            }
            else
                lblError.Text = "Keine Auswahl Aktions-Option";
        }

        // ------------------------------------------------------------------------------------------
        // Aktion : ValidDate am Stichdatum löschen
        // ------------------------------------------------------------------------------------------
        protected void btnApplyDelete_Click( object sender, EventArgs e )
        {
            MEActionOptions option = this.cbActionOption.SelectedIndex >= 0 ? 
                (MEActionOptions)this.cbActionOption.SelectedRow.Cells.FromKey( "Value" ).Value : 
                MEActionOptions.ForAllValidDates;

            if ( (option == MEActionOptions.RefDateDelete && this.edActionRefDate.Value != null) || 
                  option == MEActionOptions.DeleteAllValidDates )
            {
                for ( int i=0; i < this.dsEmplCost1.Tables[parentTable].Rows.Count; i++ )
                {
                    DataRow parentRow = this.dsEmplCost1.Tables[parentTable].Rows[i];
                    DataRow[] childRows = parentRow.GetChildRows( this.dsEmplCost1.Relations[0] );

                    for ( int j=0; j < childRows.Length; j++ )
                    {
                        DataRow row = childRows[j];

                        switch ( option )
                        {
                            case MEActionOptions.RefDateDelete:
                                if ( row["ValidFrom"].Equals( this.edActionRefDate.Value ) )
                                    row.Delete();
                                break;
                            case MEActionOptions.DeleteAllValidDates:
                                row.Delete();
                                break;
                        }
                    }
                }
                // Änderungen Speichern
                btnSave_Click( sender, e );
                // Reload saved data
                LoadEmplCost();
            }
            else
                lblError.Text = "Falsche Auswahl Aktions-Option oder Stichdatum undefiniert";
        }

        // ------------------------------------------------------------------------------------------
        // Kosten für MA der ausgewählten Organisation laden
        // ------------------------------------------------------------------------------------------
        private void LoadOrgTree( MOrgClient clientNode )
        {
            try
            {
                // Load Organisation Data (Composite-Pattern)
                new MOrgBroker().LoadOrganisation( clientNode );
                // TreeView-Control initialisieren
                new MIGWebTree( this.orgTree ).Initialize( clientNode );
            }
            catch ( Exception x )
            {
                new ErrorLogger().LogError( x );
                this.lblError.Text = ErrorLogger.StandardCommonErrorMsg;
            }
        }

        // ------------------------------------------------------------------------------------------
        // Kosten für MA der ausgewählten Organisation laden
        // ------------------------------------------------------------------------------------------
        private void LoadEmplCost()
        {
            try
            {
                // Aktuelles Select Kommando aus Kontext verwenden
                this.daEmplCostParent.SelectCommand.CommandText = pageContext.SelectParentCmd;
                if ( daEmplCostParent.SelectCommand.CommandText.Length > 0 )
                {
                    // Clear falls Daten aus dem letzten Select vorhanden
                    this.dsEmplCost1.Employee.Rows.Clear();
                    // Daten laden
                    this.daEmplCostParent.Fill( dsEmplCost1.Employee );
                    this.daEmplCostChild.Fill( dsEmplCost1.MIS_EmplCost );
                    this.grid.DataSource = this.dsEmplCost1.Employee;
                    // DataBind -> fires Initialize_Layout
                    this.grid.DataBind();
                }
            }
            catch ( Exception x )
            {
                new ErrorLogger().LogError( x );
                this.lblError.Text = ErrorLogger.StandardCommonErrorMsg;
            }
        }

        // ------------------------------------------------------------------------------------------
        // Die Auswahl der Organisation hat geändert
        // ------------------------------------------------------------------------------------------
        private void ClearSearchFields( object sender )
        {
            if ( this.orgTree != sender )
                this.orgTree.SelectedNode = null;
            if ( this.BtnSearchByPNr != sender )
                this.edSearchPersNr.Text = "";
            if ( this.BtnSearchByName != sender )
                this.edSearchName.Text = "";
            if ( this.BtnSearchByCost != sender )
                this.cbSearchCost.SelectedIndex = -1;
            if ( this.BtnSearchByAddOnCost != sender )
                this.cbSearchAddOnCost.SelectedIndex = -1;
        }

        // ------------------------------------------------------------------------------------------
        // Event-Handler : Neue Zeilen ( nur Band[1] )
        // ------------------------------------------------------------------------------------------
        protected void grid_AddRowBatch( object sender, RowEventArgs e )
        {
            try
            {
                // Neue Zeile der DataSet-Tabelle erzeugen
                DataTable table = this.dsEmplCost1.Tables[e.Row.Band.BaseTableName];
                if ( table.ParentRelations.Count > 0 )
                {
                    DataRow row = table.NewRow();

                    // Parent Column initialisieren
                    row[table.ParentRelations[0].ChildColumns[0]] = e.Row.ParentRow.Cells.FromKey( table.ParentRelations[0].ParentColumns[0].ColumnName ).Value;
                    e.Row.Cells.FromKey( table.ParentRelations[0].ChildColumns[0].ColumnName ).Value = row[table.ParentRelations[0].ChildColumns[0]];

                    // Temp. Wert für PrimaryKey setzen (für UpdateCellBatch)
                    row["EmplCostId"] = ++emplCostKey;

                    // Neue Zeile dem DataSet hinzufügen
                    this.dsEmplCost1.EnforceConstraints = false;
                    table.Rows.Add( row );

                    // Neue Grid Zeile : PrimaryKey im Row-Object setzen
                    e.Row.DataKey = row[table.PrimaryKey[0]];
                    // Neue Grid Zeile : PrimaryKey im Cell-Object setzen
                    e.Row.Cells.FromKey( table.PrimaryKey[0].ColumnName ).Value = e.Row.DataKey;
                }
            }
            catch ( Exception x )
            {
                new ErrorLogger().LogError( x );
                this.lblError.Text = ErrorLogger.StandardCommonErrorMsg;
            }

        }

        // ------------------------------------------------------------------------------------------
        // Event-Handler : Zeile löschen
        // ------------------------------------------------------------------------------------------
        protected void grid_DeleteRowBatch( object sender, RowEventArgs e )
        {
            DataTable table = null;
            DataRow row = null;
            object key = e.Row.DataKey;
            table = this.dsEmplCost1.Tables[e.Row.Band.BaseTableName];

            // Zeile suchen, welche gelöscht werden soll
            if ( key != null ) 
                row = table.Rows.Find( key );

            if ( row != null )
            {
                try
                {
                    row.Delete();
                }
                catch ( Exception x )
                {
                    this.dsEmplCost1.RejectChanges();
                    new ErrorLogger().LogError( x );
                    this.lblError.Text = ErrorLogger.StandardCommonErrorMsg;
                }
            }
        }

        // ------------------------------------------------------------------------------------------
        // Event-Handler : Zelle aktualisieren
        // ------------------------------------------------------------------------------------------
        protected void grid_UpdateCellBatch( object sender, CellEventArgs e )
        {
            DataRow row = null;
            DataTable table = null;
            object key = e.Cell.Row.DataKey;

            table = this.dsEmplCost1.Tables[e.Cell.Band.BaseTableName];

            // Zeile suchen, welche aktualisert werden soll
            if ( key != null )
                row = table.Rows.Find( key );

            //Try to update the cell in this row.
            if ( row != null )
            {
                try
                {
                    object newVal=e.Cell.Value;
                    if ( e.Cell.Key.Equals( "GlobalCostCategoryId" ) || e.Cell.Key.Equals( "GlobalCostAddOnId" ) )
                    {
                        if ( Convert.ToInt32( e.Cell.Value ) == 0 )
                            row[e.Cell.Column.Key] = DBNull.Value;
                        else
                            row[e.Cell.Column.Key] = newVal;
                    }
                    else
                        row[e.Cell.Column.Key] = newVal;
                }
                catch ( Exception x )
                {
                    this.dsEmplCost1.RejectChanges();
                    new ErrorLogger().LogError( x );
                    this.lblError.Text = ErrorLogger.StandardCommonErrorMsg;
                }
            }
        }

        // ------------------------------------------------------------------------------------------
        // Event-Handler : Alle Änderungen speichern
        // ------------------------------------------------------------------------------------------
        protected void btnSave_Click( object sender, EventArgs e )
        {
            OleDbTransaction trans = null;
            try
            {
                // Transaktion Save Globale Kosten
                this.oleDbConnection1.Open();
                trans = this.oleDbConnection1.BeginTransaction();

                // Primary Key's innerhalb Transaktion setzen
                DataRow[] addedRows = this.dsEmplCost1.Tables[childTable].Select( null, null, DataViewRowState.Added );
                for ( int i = 0; i < addedRows.Length; i++ )
                {
                    addedRows[i]["EmplCostId"] = MIS_Base.MTableKey.GetNextKey( this.oleDbConnection1, trans, childTable );
                }
                this.daEmplCostChild.DeleteCommand.Transaction = trans;
                this.daEmplCostChild.InsertCommand.Transaction = trans;
                this.daEmplCostChild.UpdateCommand.Transaction = trans;
                this.daEmplCostChild.Update( this.dsEmplCost1.Tables[childTable].Select( null, null, DataViewRowState.Deleted ) );
                this.daEmplCostChild.Update( this.dsEmplCost1.Tables[childTable].Select( null, null, DataViewRowState.ModifiedCurrent | DataViewRowState.Added ) );

                if ( this.dsEmplCost1.HasErrors )
                {
                    trans.Rollback();
                    this.dsEmplCost1.RejectChanges();
                    this.grid.DataBind();
                    new ErrorLogger().LogError( Page.Title + ": Save reject changes" );
                }
                else
                    trans.Commit();

            }
            catch ( Exception x )
            {
                trans.Rollback();
                this.dsEmplCost1.RejectChanges();
                new ErrorLogger().LogError( x );
                this.lblError.Text = ErrorLogger.StandardCommonErrorMsg;
            }
            finally
            {
                this.oleDbConnection1.Close();
            }

        }

        // ------------------------------------------------------------------------------------------
        // Benutzerrechte für die Seite allg. setzen
        // ------------------------------------------------------------------------------------------
        private void SetupRights( MUser user )
        {
            // Um Aktionen ausführen zu können müssen alle Rechte vorhanden sein
            if ( !user.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Write ) &&
                 !user.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Create ) &&
                 !user.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Del ) )
            {
                this.webTab.Tabs.FromKey( "Tab_Action" ).Visible = false;
                this.btnApplyDelete.Enabled = false;
                this.btnApplyCostCategory.Enabled = false;
                this.btnApplyAddOnCost.Enabled = false;
                this.btnApplyLocked.Enabled = false;
            }
        }

        // ------------------------------------------------------------------------------------------
        // Benutzerrechte für die Tabelle (erst nach DataBind() damit Band[1] definiert ist)
        // ------------------------------------------------------------------------------------------
        private void SetupGridRights( MUser user )
        {
            if ( !user.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Write ) &&
                 !user.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Create ) &&
                 !user.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Del ) )
            {
                this.btnSave.Enabled = false;
            }
            // Update
            if ( !user.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Write ) )
                this.grid.Bands[1].AllowUpdate = AllowUpdate.No;
            // Insert
            if ( !user.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Create ) )
            {
                this.grid.Bands[1].AllowAdd = AllowAddNew.No;
                this.grid.DisplayLayout.AddNewBox.Hidden = true;
            }
            // Delete
            if ( !user.HasObjectRights( MUser.ObjectCmd.aEmplCost, (int)MUser.BasicRight.Del ) )
            {
                this.grid.Bands[1].AllowDelete = AllowDelete.No;
            }
        }

    }
}
